/**
 * @file Figure.h
 * @brief LN^tBMANX錾
 * @author cherub
 */
#ifndef HUMAN_FIGURE_CLASS_HEADER_FILE_
#define HUMAN_FIGURE_CLASS_HEADER_FILE_
#pragma once

#include "Joint.h"
#include "MotionData.h"

/**
 * @class CFigure Figure.h
 * @brief LN^tBMANX
 * @author cherub
 */
class CFigure
{
//
// variables
private:
	//! [gm[h
	CJoint *m_pRoot;
	//! ֐߃m[hXg
	std::vector<CJoint*> m_vecJoints;

//
// constructor/destructor
public:
	// ftHgRXgN^
	CFigure();
	// qtRXgN^
	CFigure(CJoint *root);
	// fXgN^
	virtual ~CFigure(void);

//
// initializer
public:
	void Initialize(CJoint *root);

//
// internal operator
private:
	// XPg؍\̃m[hXg̍쐬
	void ListingJoint(CJoint *root);

//
// attributes
public:
	/**
	 * @fn bool IsActive() const
	 * @brief tBMAp\`FbN
	 * @retval true p\
	 * @retval false ps
	 */
	bool IsActive() const;
	// ֐ߑ̎擾
	size_t NumJoints() const;

//
// accessor
public:
	// [gʒu̐ݒ
	void SetRootPosition(const D3DXVECTOR3 &pos);
	// [gʒu̎擾
	D3DXVECTOR3 GetRootPosition() const;
	// [g̐ݒ
	void SetRootOrientation(const D3DXQUATERNION &rot);
	// [g̎擾
	D3DXQUATERNION GetRootOrientation() const;
	// ֐߉]ʂ̐ݒ
	void SetJointRotation(size_t jid, const D3DXQUATERNION &rot);
	// ֐߉]ʂ̎擾
	D3DXQUATERNION GetJointRotation(size_t jid) const;

	// [gm[hւ̃|C^̎擾
	CJoint* GetRoot();
	// [gm[hւ̃|C^̎擾(const)
	const CJoint* GetRoot() const;
	// ֐߃m[hւ̃|C^̎擾
	CJoint* GetJoint(size_t jid);
	// ֐߃m[hւ̃|C^̎擾(const)
	const CJoint* GetJoint(size_t jid) const;

	// ֐߃m[hւ̃|C^m[hCfNX̌
	int FindNode(CJoint *node) const;
	// ֐߃m[hm[hCfNX̌
	int FindNode(const char *name) const;
	// ֐߃m[hGtFN^`FbN
	bool IsEffector(size_t jid) const;

//
// forward kinematics
public:
	// ֐߃m[h̃[hWxNg̎擾
	D3DXVECTOR3 GetWorldPosition(size_t jid) const;

//
// motion data
public:
	bool SetPose(const CMotionData *mot, size_t frm);
};

#endif //HUMAN_FIGURE_CLASS_HEADER_FILE_
