/**
 * @file Joint.cpp
 * @brief ֐߃NX`
 * @author cherub
 */
#include "stdafx.h"
#include "Joint.h"

/**
 * @fn CJoint::CJoint(const D3DXVECTOR3 &offset, const CJoint* parent)
 * @brief qtRXgN^
 * @param offset [in] ItZbgxNg
 * @param parent [in] e֐߃m[hւ̃|C^
 */
CJoint::CJoint(const D3DXVECTOR3 &offset, const CJoint* parent)
{
	m_pszName = NULL;
	Initialize(offset, parent);
}

/**
 * @fn CJoint::~CJoint(void)
 * @brief fXgN^
 */
CJoint::~CJoint(void)
{
}

/**
 * @fn void CJoint::Destroy()
 * @brief m[h̔j
 */
void CJoint::Destroy()
{
	if (m_pszName != NULL)
		delete[] m_pszName;
	delete this;
}

/**
 * @fn void CJoint::Initialize(D3DXVECTOR3 offset, const CJoint *parent)
 * @brief ֐
 * @param offset [in] ItZbgxNg
 * @param parent [in] e֐߃m[hւ̃|C^
 */
void CJoint::Initialize(D3DXVECTOR3 offset, const CJoint *parent)
{
	SetOffset(offset);
	SetRotation(D3DXQUATERNION(0, 0, 0, 1));
	SetPosition(D3DXVECTOR3(0, 0, 0));
	SetParent(parent);
	if (m_pszName != NULL)
		delete[] m_pszName;
	m_pszName = NULL;
}

/**
 * @fn D3DXMATRIX CJoint::GetInitialTransform() const
 * @brief {[̏gXtH[DxNg(0, 0, 1)ɑ΂Ē`D
 * @return gXtH[s
 */
D3DXMATRIX CJoint::GetInitialTransform() const
{
	return m_mInit;
}

/**
 * @fn void CJoint::SetOffset(const D3DXVECTOR3 &offset)
 * @brief ItZbgxNg̐ݒ
 * @param offset [in] ItZbgxNg
 */
void CJoint::SetOffset(const D3DXVECTOR3 &offset)
{
	m_vOffset = offset;
	float offset_len = D3DXVec3Length(&offset);

	if (offset_len <= 0)
	{
		m_mInit *= 0;
	}
	else
	{
		D3DXVECTOR3 vz(0, 0, 1), vaxis(0, 0, 0);

		float angle = acosf(offset.z / offset_len);
		D3DXVec3Cross(&vaxis, &vz, &offset);

		D3DXMatrixScaling(&m_mInit, 0.2f * offset_len, 0.2f * offset_len, offset_len);
		m_mInit._43 += offset_len / 2.0f;

		D3DXMATRIX tmp;
		D3DXMatrixRotationAxis(&tmp, &vaxis, angle);
		m_mInit *= tmp;
	}
}

/**
 * @fn D3DXMATRIX CJoint::GetOffsetMatrix() const
 * @brief ItZbgs̎擾
 * @return ItZbgs
 */
D3DXMATRIX CJoint::GetOffsetMatrix() const
{
	D3DXMATRIX m;
	return *D3DXMatrixTranslation(&m, m_vOffset.x, m_vOffset.y, m_vOffset.z);
}

/**
 * @fn void CJoint::SetRotation(const D3DXQUATERNION &q)
 * @brief ]NH[^jI̐ݒ
 * @param q [in] ]NH[^jI
 */
void CJoint::SetRotation(const D3DXQUATERNION &q)
{
	m_qRotation = q;
}

/**
 * @fn void CJoint::SetPosition(const D3DXVECTOR3 &pos)
 * @brief ʒuxNg̐ݒ
 * @param pos [in] ʒuxNg
 */
void CJoint::SetPosition(const D3DXVECTOR3 &pos)
{
	m_vPosition = pos;
}

/**
 * @fn D3DXMATRIX CJoint::GetRotationMatrix() const
 * @brief ]s̎擾
 * @return ]s
 */
D3DXMATRIX CJoint::GetRotationMatrix() const
{
	D3DXMATRIX m;
	return *D3DXMatrixRotationQuaternion(&m, &m_qRotation);
}

/**
 * @fn D3DXMATRIX CJoint::GetPositionMatrix() const
 * @brief ʒus̎擾
 * @return ʒus
 */
D3DXMATRIX CJoint::GetPositionMatrix() const
{
	D3DXMATRIX m;
	return *D3DXMatrixTranslation(&m, m_vPosition.x, m_vPosition.y, m_vPosition.z);
}

/**
 * @fn D3DXMATRIX CJoint::GetTransformMatrix() const
 * @brief ֐߃gXtH[s̎擾
 * @return ֐߃gXtH[s
 */
D3DXMATRIX CJoint::GetTransformMatrix() const
{
	return GetRotationMatrix() * GetOffsetMatrix() * GetPositionMatrix();
}

/**
 * @fn void CJoint::SetParent(const CJoint *node)
 * @brief e֐߃m[h̎擾
 * @return e֐߃m[hւ̃|C^
 */
void CJoint::SetParent(const CJoint *node)
{
	CTreeNode::SetParent(node);
}

/**
 * @fn void CJoint::AddChild(CJoint *node)
 * @brief q֐߃m[h̒ǉ
 * @param node [in] q֐߃m[hւ̃|C^
 */
void CJoint::AddChild(CJoint *node)
{
	CTreeNode::AddChild(node);
}

/**
 * @fn void CJoint::SetName(const char *name)
 * @brief ֐ߖ̐ݒ
 * @param name [in] ֐ߖ
 */
void CJoint::SetName(const char *name)
{
	if (name == NULL)
		return;

	if (m_pszName != NULL)
		delete[] m_pszName;
	if (m_pszName = new char[strlen(name) + 1], m_pszName == NULL)
		return;
	strcpy(m_pszName, name);
}
