// SceneView.h : CSceneView NX̃C^[tFCX
//


#pragma once

#define	WM_USER_RENDER_SCENE	(WM_USER + 1)

#include "Figure.h"
#include "MotionData.h"

// ǉ {
enum JointID
{
	JID_ROOT, JID_CHEST, JID_NECK, JID_HEAD,
	JID_LSHOULDER, JID_LELBOW, JID_LWRIST, JID_LHAND,
	JID_RSHOULDER, JID_RELBOW, JID_RWRIST, JID_RHAND,
	JID_LHIP, JID_LKNEE, JID_LANKLE, JID_LFOOT,
	JID_RHIP, JID_RKNEE, JID_RANKLE, JID_RFOOT,
	JID_NUM
};
// } ǉ


class CSceneView : public CView
{
protected: // VÂݍ쐬܂B
	CSceneView();
	DECLARE_DYNCREATE(CSceneView)

// 
public:
	CMainDoc* GetDocument() const;

// 
public:

// I[o[Ch
public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CSceneView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif


protected:
	LPDIRECT3D9 m_pD3D;
	LPDIRECT3DDEVICE9 m_pDeviceD3D;


/*
 * ǉ
 */
protected:
	LPD3DXEFFECT m_pEffect;
	D3DXHANDLE m_hTechPhong;

	D3DXHANDLE m_hWorld;
	D3DXHANDLE m_hWorldIT;
	D3DXHANDLE m_hWorldViewProj;
	D3DXHANDLE m_hEyePos;

protected:
	D3DXMATRIX m_mProjection;
	D3DXMATRIX m_mView;
	D3DXVECTOR3 m_pvView[3];
	D3DXMATRIX m_pmViewTrans[3];
	POINT m_pntDown;

	LPD3DXMESH m_pMeshSphere;
	CFigure	*m_pFigure;
	CMotionData *m_pMotion;

protected:
	HRESULT InitDirectGraphics(void);
	HRESULT InitRenderState(void);
	HRESULT InitHLSL(void);
	HRESULT DrawMeshSub(const LPD3DXMESH pMesh, const D3DXMATRIX &mWorld) const;

protected:
	void DrawSkeletonSub(const CJoint *pJoint, LPD3DXMATRIXSTACK &pMatStack);
	void DrawSkeleton();
	void DrawGround();

protected:
	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnRenderScene(WPARAM wPara, LPARAM lPara);
	virtual void OnInitialUpdate();
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnFileOpen();
public:
	afx_msg void OnFileSaveAs();
public:
	afx_msg void OnUpdateFileSaveAs(CCmdUI *pCmdUI);
};

#ifndef _DEBUG  // SceneView.cpp ̃fobO o[W
inline CMainDoc* CSceneView::GetDocument() const
   { return reinterpret_cast<CMainDoc*>(m_pDocument); }
#endif

