/**
 * @file TreeNode.cpp
 * @brief ؍\NX`
 * @author cherub
 */
#include "stdafx.h"
#include "TreeNode.h"
#include <algorithm>

/**
 * @fn CTreeNode::CTreeNode()
 * @brief ftHgRXgN^
 */
CTreeNode::CTreeNode()
{
	m_pParent = NULL;
}

/**
 * @fn CTreeNode::~CTreeNode()
 * @brief fXgN^
 */
CTreeNode::~CTreeNode()
{
	Destroy();
}

/**
 * @fn void CTreeNode::Destroy()
 * @brief qm[h܂߂m[h̔j
 */
void CTreeNode::Destroy()
{
	for (std::vector<CTreeNode*>::iterator it = m_vecChildren.begin();it != m_vecChildren.end();++it)
		(*it)->Destroy();
}

/**
 * @fn void CTreeNode::AddChild(CTreeNode *child)
 * @brief qm[hǉ
 * @param child [in] ǉm[h
 */
void CTreeNode::AddChild(CTreeNode *child)
{
	child->SetParent(this);
	m_vecChildren.push_back(child);
}

/**
 * @fn CTreeNode* CTreeNode::GetChild(size_t nid)
 * @brief qm[h擾
 * @param nid [in] 擾m[h̃CfbNX
 * @retval NULL CfbNX͈͊O
 * @retval otherwise m[hւ̃|C^
 */
CTreeNode* CTreeNode::GetChild(size_t nid)
{
	if (nid >= m_vecChildren.size())
		return NULL;
	return m_vecChildren[nid];
}
/**
 * @fn const CTreeNode* CTreeNode::GetChild(size_t nid) const
 * @brief qm[h擾(const)
 * @param nid [in] 擾m[h̃CfbNX
 * @retval NULL CfbNX͈͊O
 * @retval otherwise m[hւ̃|C^(const)
 */
const CTreeNode* CTreeNode::GetChild(size_t nid) const
{
	if (nid >= m_vecChildren.size())
		return NULL;
	return m_vecChildren[nid];
}

/**
 * @fn CTreeNode* CTreeNode::GetRoot()
 * @brief [gm[h擾
 * @return [gm[hւ̃|C^
 */
CTreeNode* CTreeNode::GetRoot()
{
	CTreeNode *tmp, *node = this;
	while ((tmp = node->GetParent()) != NULL)
		node = tmp;
	return node;
}

/**
 * @fn const CTreeNode* CTreeNode::GetRoot() const
 * @brief [gm[h擾(const)
 * @return [gm[hւconst|C^
 */
const CTreeNode* CTreeNode::GetRoot() const
{
	const CTreeNode *tmp, *node = this;
	while ((tmp = node->GetParent()) != NULL)
		node = tmp;
	return node;
}

/**
 * @fn size_t CTreeNode::FindChild(const CTreeNode *node) const
 * @brief qm[h
 * @param node [in] m[h
 * @retval NumChildren() wm[h݂͑Ȃ
 * @retval otherwise wm[h̃CfbNX
 */
size_t CTreeNode::FindChild(const CTreeNode *node) const
{
	return std::find(m_vecChildren.begin(), m_vecChildren.end(), node) - m_vecChildren.begin();
}

/**
 * @fn bool CTreeNode::RemoveNode(size_t nid)
 * @brief m[h폜
 * @param nid [in] 폜m[h̃CfbNX
 * @retval true 폜
 * @retval false 폜sC͎wm[h݂Ȃ
 */
bool CTreeNode::RemoveNode(size_t nid)
{
	if (nid >= m_vecChildren.size())
		return false;
	m_vecChildren.erase(m_vecChildren.begin() + nid);
	return true;
}
